/*
 * This is part of the doxml library, a parser for XML.  It should not
 *  require any functionality not defined in ANSI C's standard libraries.
 *
 * Copyright (C) 1999 John Stracke, http://www.thibault.org
 *
 * This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 * $Log: utf8.h,v $
 * Revision 1.2  1999/07/18 22:36:58  francis
 * Adding support for character entities
 *
 * Revision 1.1  1999/07/18 22:00:20  francis
 * Adding basic Unicode-to-UTF8 conversion, needed for character entities
 *
 */
#ifndef _DOXML_DOXML_UTF8_H_
#define _DOXML_DOXML_UTF8_H_

static const char* _doxml_version_ident_doxml_utf8_h="$Id: utf8.h,v 1.2 1999/07/18 22:36:58 francis Exp $";

/* Note that the int type is meant to be 32 bits, and might have to be
 *  modified depending on the platform.
 */
typedef union {
  unsigned char bytes[4];
  int word; /* in network order */
} doxml_unicode_char;

/* Converts a single Unicode character to UTF-8.  On exit, buff is
 *  0-terminated.  Returns the number of characters used, or <0 on error.
 */
int doxml_unicode_char_to_utf8(const doxml_unicode_char* unicode,
                               char* buff,
                               int bufflen);

unsigned int doxml_word_host_to_network_order(unsigned int word);

#endif /*_DOXML_DOXML_UTF8_H_*/
