/*
 * This is part of the doxml library, a parser for XML.  It should not
 *  require any functionality not defined in ANSI C's standard libraries.
 *
 * Copyright (C) 1999 John Stracke, http://www.thibault.org
 *
 * This library is free software; you can redistribute it and/or
 *  modify it under the terms of the GNU Library General Public License
 *  as published by the Free Software Foundation; either version 2 of
 *  the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful, but
 *  WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 *  Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 *  License along with this library; if not, write to the Free Software
 *  Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
 *  02111-1307, USA.
 *
 * $Log: file.c,v $
 * Revision 1.3  1999/05/21 23:05:42  francis
 * Finished renaming to doxml
 *
 * Revision 1.2  1999/05/21 22:59:48  francis
 * Partially renaming to doxml
 *
 * Revision 1.1.1.1  1999/05/21 22:20:36  francis
 * Initial checkin of libxml, to be renamed doxml
 *
 */

static const char* id="$Id: file.c,v 1.3 1999/05/21 23:05:42 francis Exp $";

#include <doxml/xml.h>

doxml_context*
doxml_open_file(const char* path)
{
  doxml_context* context;
  FILE* stream=fopen(path,"r");
  if (!stream)
    {
      fprintf(stderr,"doxml: doxml_open_file(): cannot open file\n");
      return 0;
    }

  context=doxml_open_stream(stream,1);
  if (!context)
    {
      fprintf(stderr,"doxml: doxml_open_file(): doxml_open_stream() failed\n");
      fclose(stream);
      return 0;
    }

  return context;
}
