#include <doxml/utf8.h>
#include <stdio.h>

int single(const doxml_unicode_char* u)
{
  char buff[20];
  int nbytes;

  nbytes=doxml_unicode_char_to_utf8(u,buff,sizeof(buff));
  if (nbytes<0)
    {
      fprintf(stderr,"doxml_unicode_char_to_utf8() failed\n");
      return 1;
    }
  else
    {
      printf("%s",buff);
      return 0;
    }
}

void usage(const char* progname)
{
  fprintf(stderr,"Usage: %s {--a|--hangugo|--nihongo}\n");
  exit(2);
}

int main(int argc, const char* argv[])
{
  int res;
  doxml_unicode_char u;

  if (argc!=2)
    usage(argv[1]);

  if (!strcmp(argv[1],"--nihongo"))
    {
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0x65;
      u.bytes[3]=0xe5;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0x67;
      u.bytes[3]=0x2c;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0x8a;
      u.bytes[3]=0x9e;
      if (res=single(&u))
        return res;
      return 0;
    }

  if (!strcmp(argv[1],"--hangugo"))
    {
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0xd5;
      u.bytes[3]=0x5c;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0xad;
      u.bytes[3]=0x6d;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0xc5;
      u.bytes[3]=0xb4;
      if (res=single(&u))
        return res;
      return 0;
    }

  if (!strcmp(argv[1],"--a"))
    {
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0;
      u.bytes[3]=0x41;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0x22;
      u.bytes[3]=0x62;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0x03;
      u.bytes[3]=0x91;
      if (res=single(&u))
        return res;
      
      u.bytes[0]=0;
      u.bytes[1]=0;
      u.bytes[2]=0;
      u.bytes[3]=0x2e;
      if (res=single(&u))
        return res;
      return 0;
    }

  usage(argv[0]);
}
